// Package api provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen/v2 version v2.0.0 DO NOT EDIT.
package api

import (
	"bytes"
	"compress/gzip"
	"context"
	"encoding/base64"
	"fmt"
	"io"
	"net/http"
	"net/url"
	"path"
	"strings"

	"github.com/getkin/kin-openapi/openapi3"
	"github.com/go-chi/chi/v5"
	"github.com/oapi-codegen/runtime"
	strictnethttp "github.com/oapi-codegen/runtime/strictmiddleware/nethttp"
	openapi_types "github.com/oapi-codegen/runtime/types"
)

// FSCVWLSysteem defines model for FSCVWLSysteem.
type FSCVWLSysteem = string

// FSCVWLVerantwoordelijke defines model for FSCVWLVerantwoordelijke.
type FSCVWLVerantwoordelijke = string

// FSCVWLVerwerker defines model for FSCVWLVerwerker.
type FSCVWLVerwerker = string

// FSCVWLVerwerkingsActiviteit defines model for FSCVWLVerwerkingsActiviteit.
type FSCVWLVerwerkingsActiviteit = string

// FSCVWLVerwerkingsSpan defines model for FSCVWLVerwerkingsSpan.
type FSCVWLVerwerkingsSpan = openapi_types.UUID

// PostVWLParams defines parameters for PostVWL.
type PostVWLParams struct {
	// FSCVWLVerwerkingsActiviteit id of the verwerking type
	FSCVWLVerwerkingsActiviteit *FSCVWLVerwerkingsActiviteit `json:"FSC-VWL-Verwerkings-Activiteit,omitempty"`

	// FSCVWLVerwerkingsSpan transaction uuid of the incoming request
	FSCVWLVerwerkingsSpan *FSCVWLVerwerkingsSpan `json:"FSC-VWL-Verwerkings-Span,omitempty"`

	// FSCVWLSysteem identifier for the system processing the verwerking
	FSCVWLSysteem *FSCVWLSysteem `json:"FSC-VWL-Systeem,omitempty"`

	// FSCVWLVerwerker the party doing the verwerking, this does not have to be the party responsible for the verwerking
	FSCVWLVerwerker *FSCVWLVerwerker `json:"FSC-VWL-Verwerker,omitempty"`

	// FSCVWLVerantwoordelijke the party responsible for the verwerking, this does not have to be the party doing the verwerking itself
	FSCVWLVerantwoordelijke *FSCVWLVerantwoordelijke `json:"FSC-VWL-Verantwoordelijke,omitempty"`
}

// RequestEditorFn  is the function signature for the RequestEditor callback function
type RequestEditorFn func(ctx context.Context, req *http.Request) error

// Doer performs HTTP requests.
//
// The standard http.Client implements this interface.
type HttpRequestDoer interface {
	Do(req *http.Request) (*http.Response, error)
}

// Client which conforms to the OpenAPI3 specification for this service.
type Client struct {
	// The endpoint of the server conforming to this interface, with scheme,
	// https://api.deepmap.com for example. This can contain a path relative
	// to the server, such as https://api.deepmap.com/dev-test, and all the
	// paths in the swagger spec will be appended to the server.
	Server string

	// Doer for performing requests, typically a *http.Client with any
	// customized settings, such as certificate chains.
	Client HttpRequestDoer

	// A list of callbacks for modifying requests which are generated before sending over
	// the network.
	RequestEditors []RequestEditorFn
}

// ClientOption allows setting custom parameters during construction
type ClientOption func(*Client) error

// Creates a new Client, with reasonable defaults
func NewClient(server string, opts ...ClientOption) (*Client, error) {
	// create a client with sane default values
	client := Client{
		Server: server,
	}
	// mutate client and add all optional params
	for _, o := range opts {
		if err := o(&client); err != nil {
			return nil, err
		}
	}
	// ensure the server URL always has a trailing slash
	if !strings.HasSuffix(client.Server, "/") {
		client.Server += "/"
	}
	// create httpClient, if not already present
	if client.Client == nil {
		client.Client = &http.Client{}
	}
	return &client, nil
}

// WithHTTPClient allows overriding the default Doer, which is
// automatically created using http.Client. This is useful for tests.
func WithHTTPClient(doer HttpRequestDoer) ClientOption {
	return func(c *Client) error {
		c.Client = doer
		return nil
	}
}

// WithRequestEditorFn allows setting up a callback function, which will be
// called right before sending the request. This can be used to mutate the request.
func WithRequestEditorFn(fn RequestEditorFn) ClientOption {
	return func(c *Client) error {
		c.RequestEditors = append(c.RequestEditors, fn)
		return nil
	}
}

// The interface specification for the client above.
type ClientInterface interface {
	// PostVWL request
	PostVWL(ctx context.Context, params *PostVWLParams, reqEditors ...RequestEditorFn) (*http.Response, error)
}

func (c *Client) PostVWL(ctx context.Context, params *PostVWLParams, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewPostVWLRequest(c.Server, params)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

// NewPostVWLRequest generates requests for PostVWL
func NewPostVWLRequest(server string, params *PostVWLParams) (*http.Request, error) {
	var err error

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/VWL")
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("POST", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	if params != nil {

		if params.FSCVWLVerwerkingsActiviteit != nil {
			var headerParam0 string

			headerParam0, err = runtime.StyleParamWithLocation("simple", false, "FSC-VWL-Verwerkings-Activiteit", runtime.ParamLocationHeader, *params.FSCVWLVerwerkingsActiviteit)
			if err != nil {
				return nil, err
			}

			req.Header.Set("FSC-VWL-Verwerkings-Activiteit", headerParam0)
		}

		if params.FSCVWLVerwerkingsSpan != nil {
			var headerParam1 string

			headerParam1, err = runtime.StyleParamWithLocation("simple", false, "FSC-VWL-Verwerkings-Span", runtime.ParamLocationHeader, *params.FSCVWLVerwerkingsSpan)
			if err != nil {
				return nil, err
			}

			req.Header.Set("FSC-VWL-Verwerkings-Span", headerParam1)
		}

		if params.FSCVWLSysteem != nil {
			var headerParam2 string

			headerParam2, err = runtime.StyleParamWithLocation("simple", false, "FSC-VWL-Systeem", runtime.ParamLocationHeader, *params.FSCVWLSysteem)
			if err != nil {
				return nil, err
			}

			req.Header.Set("FSC-VWL-Systeem", headerParam2)
		}

		if params.FSCVWLVerwerker != nil {
			var headerParam3 string

			headerParam3, err = runtime.StyleParamWithLocation("simple", false, "FSC-VWL-Verwerker", runtime.ParamLocationHeader, *params.FSCVWLVerwerker)
			if err != nil {
				return nil, err
			}

			req.Header.Set("FSC-VWL-Verwerker", headerParam3)
		}

		if params.FSCVWLVerantwoordelijke != nil {
			var headerParam4 string

			headerParam4, err = runtime.StyleParamWithLocation("simple", false, "FSC-VWL-Verantwoordelijke", runtime.ParamLocationHeader, *params.FSCVWLVerantwoordelijke)
			if err != nil {
				return nil, err
			}

			req.Header.Set("FSC-VWL-Verantwoordelijke", headerParam4)
		}

	}

	return req, nil
}

func (c *Client) applyEditors(ctx context.Context, req *http.Request, additionalEditors []RequestEditorFn) error {
	for _, r := range c.RequestEditors {
		if err := r(ctx, req); err != nil {
			return err
		}
	}
	for _, r := range additionalEditors {
		if err := r(ctx, req); err != nil {
			return err
		}
	}
	return nil
}

// ClientWithResponses builds on ClientInterface to offer response payloads
type ClientWithResponses struct {
	ClientInterface
}

// NewClientWithResponses creates a new ClientWithResponses, which wraps
// Client with return type handling
func NewClientWithResponses(server string, opts ...ClientOption) (*ClientWithResponses, error) {
	client, err := NewClient(server, opts...)
	if err != nil {
		return nil, err
	}
	return &ClientWithResponses{client}, nil
}

// WithBaseURL overrides the baseURL.
func WithBaseURL(baseURL string) ClientOption {
	return func(c *Client) error {
		newBaseURL, err := url.Parse(baseURL)
		if err != nil {
			return err
		}
		c.Server = newBaseURL.String()
		return nil
	}
}

// ClientWithResponsesInterface is the interface specification for the client with responses above.
type ClientWithResponsesInterface interface {
	// PostVWLWithResponse request
	PostVWLWithResponse(ctx context.Context, params *PostVWLParams, reqEditors ...RequestEditorFn) (*PostVWLResponse, error)
}

type PostVWLResponse struct {
	Body         []byte
	HTTPResponse *http.Response
}

// Status returns HTTPResponse.Status
func (r PostVWLResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r PostVWLResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

// PostVWLWithResponse request returning *PostVWLResponse
func (c *ClientWithResponses) PostVWLWithResponse(ctx context.Context, params *PostVWLParams, reqEditors ...RequestEditorFn) (*PostVWLResponse, error) {
	rsp, err := c.PostVWL(ctx, params, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParsePostVWLResponse(rsp)
}

// ParsePostVWLResponse parses an HTTP response from a PostVWLWithResponse call
func ParsePostVWLResponse(rsp *http.Response) (*PostVWLResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &PostVWLResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	return response, nil
}

// ServerInterface represents all server handlers.
type ServerInterface interface {

	// (POST /VWL)
	PostVWL(w http.ResponseWriter, r *http.Request, params PostVWLParams)
}

// Unimplemented server implementation that returns http.StatusNotImplemented for each endpoint.

type Unimplemented struct{}

// (POST /VWL)
func (_ Unimplemented) PostVWL(w http.ResponseWriter, r *http.Request, params PostVWLParams) {
	w.WriteHeader(http.StatusNotImplemented)
}

// ServerInterfaceWrapper converts contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler            ServerInterface
	HandlerMiddlewares []MiddlewareFunc
	ErrorHandlerFunc   func(w http.ResponseWriter, r *http.Request, err error)
}

type MiddlewareFunc func(http.Handler) http.Handler

// PostVWL operation middleware
func (siw *ServerInterfaceWrapper) PostVWL(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var err error

	// Parameter object where we will unmarshal all parameters from the context
	var params PostVWLParams

	headers := r.Header

	// ------------- Optional header parameter "FSC-VWL-Verwerkings-Activiteit" -------------
	if valueList, found := headers[http.CanonicalHeaderKey("FSC-VWL-Verwerkings-Activiteit")]; found {
		var FSCVWLVerwerkingsActiviteit FSCVWLVerwerkingsActiviteit
		n := len(valueList)
		if n != 1 {
			siw.ErrorHandlerFunc(w, r, &TooManyValuesForParamError{ParamName: "FSC-VWL-Verwerkings-Activiteit", Count: n})
			return
		}

		err = runtime.BindStyledParameterWithLocation("simple", false, "FSC-VWL-Verwerkings-Activiteit", runtime.ParamLocationHeader, valueList[0], &FSCVWLVerwerkingsActiviteit)
		if err != nil {
			siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "FSC-VWL-Verwerkings-Activiteit", Err: err})
			return
		}

		params.FSCVWLVerwerkingsActiviteit = &FSCVWLVerwerkingsActiviteit

	}

	// ------------- Optional header parameter "FSC-VWL-Verwerkings-Span" -------------
	if valueList, found := headers[http.CanonicalHeaderKey("FSC-VWL-Verwerkings-Span")]; found {
		var FSCVWLVerwerkingsSpan FSCVWLVerwerkingsSpan
		n := len(valueList)
		if n != 1 {
			siw.ErrorHandlerFunc(w, r, &TooManyValuesForParamError{ParamName: "FSC-VWL-Verwerkings-Span", Count: n})
			return
		}

		err = runtime.BindStyledParameterWithLocation("simple", false, "FSC-VWL-Verwerkings-Span", runtime.ParamLocationHeader, valueList[0], &FSCVWLVerwerkingsSpan)
		if err != nil {
			siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "FSC-VWL-Verwerkings-Span", Err: err})
			return
		}

		params.FSCVWLVerwerkingsSpan = &FSCVWLVerwerkingsSpan

	}

	// ------------- Optional header parameter "FSC-VWL-Systeem" -------------
	if valueList, found := headers[http.CanonicalHeaderKey("FSC-VWL-Systeem")]; found {
		var FSCVWLSysteem FSCVWLSysteem
		n := len(valueList)
		if n != 1 {
			siw.ErrorHandlerFunc(w, r, &TooManyValuesForParamError{ParamName: "FSC-VWL-Systeem", Count: n})
			return
		}

		err = runtime.BindStyledParameterWithLocation("simple", false, "FSC-VWL-Systeem", runtime.ParamLocationHeader, valueList[0], &FSCVWLSysteem)
		if err != nil {
			siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "FSC-VWL-Systeem", Err: err})
			return
		}

		params.FSCVWLSysteem = &FSCVWLSysteem

	}

	// ------------- Optional header parameter "FSC-VWL-Verwerker" -------------
	if valueList, found := headers[http.CanonicalHeaderKey("FSC-VWL-Verwerker")]; found {
		var FSCVWLVerwerker FSCVWLVerwerker
		n := len(valueList)
		if n != 1 {
			siw.ErrorHandlerFunc(w, r, &TooManyValuesForParamError{ParamName: "FSC-VWL-Verwerker", Count: n})
			return
		}

		err = runtime.BindStyledParameterWithLocation("simple", false, "FSC-VWL-Verwerker", runtime.ParamLocationHeader, valueList[0], &FSCVWLVerwerker)
		if err != nil {
			siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "FSC-VWL-Verwerker", Err: err})
			return
		}

		params.FSCVWLVerwerker = &FSCVWLVerwerker

	}

	// ------------- Optional header parameter "FSC-VWL-Verantwoordelijke" -------------
	if valueList, found := headers[http.CanonicalHeaderKey("FSC-VWL-Verantwoordelijke")]; found {
		var FSCVWLVerantwoordelijke FSCVWLVerantwoordelijke
		n := len(valueList)
		if n != 1 {
			siw.ErrorHandlerFunc(w, r, &TooManyValuesForParamError{ParamName: "FSC-VWL-Verantwoordelijke", Count: n})
			return
		}

		err = runtime.BindStyledParameterWithLocation("simple", false, "FSC-VWL-Verantwoordelijke", runtime.ParamLocationHeader, valueList[0], &FSCVWLVerantwoordelijke)
		if err != nil {
			siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "FSC-VWL-Verantwoordelijke", Err: err})
			return
		}

		params.FSCVWLVerantwoordelijke = &FSCVWLVerantwoordelijke

	}

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.PostVWL(w, r, params)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

type UnescapedCookieParamError struct {
	ParamName string
	Err       error
}

func (e *UnescapedCookieParamError) Error() string {
	return fmt.Sprintf("error unescaping cookie parameter '%s'", e.ParamName)
}

func (e *UnescapedCookieParamError) Unwrap() error {
	return e.Err
}

type UnmarshalingParamError struct {
	ParamName string
	Err       error
}

func (e *UnmarshalingParamError) Error() string {
	return fmt.Sprintf("Error unmarshaling parameter %s as JSON: %s", e.ParamName, e.Err.Error())
}

func (e *UnmarshalingParamError) Unwrap() error {
	return e.Err
}

type RequiredParamError struct {
	ParamName string
}

func (e *RequiredParamError) Error() string {
	return fmt.Sprintf("Query argument %s is required, but not found", e.ParamName)
}

type RequiredHeaderError struct {
	ParamName string
	Err       error
}

func (e *RequiredHeaderError) Error() string {
	return fmt.Sprintf("Header parameter %s is required, but not found", e.ParamName)
}

func (e *RequiredHeaderError) Unwrap() error {
	return e.Err
}

type InvalidParamFormatError struct {
	ParamName string
	Err       error
}

func (e *InvalidParamFormatError) Error() string {
	return fmt.Sprintf("Invalid format for parameter %s: %s", e.ParamName, e.Err.Error())
}

func (e *InvalidParamFormatError) Unwrap() error {
	return e.Err
}

type TooManyValuesForParamError struct {
	ParamName string
	Count     int
}

func (e *TooManyValuesForParamError) Error() string {
	return fmt.Sprintf("Expected one value for %s, got %d", e.ParamName, e.Count)
}

// Handler creates http.Handler with routing matching OpenAPI spec.
func Handler(si ServerInterface) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{})
}

type ChiServerOptions struct {
	BaseURL          string
	BaseRouter       chi.Router
	Middlewares      []MiddlewareFunc
	ErrorHandlerFunc func(w http.ResponseWriter, r *http.Request, err error)
}

// HandlerFromMux creates http.Handler with routing matching OpenAPI spec based on the provided mux.
func HandlerFromMux(si ServerInterface, r chi.Router) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{
		BaseRouter: r,
	})
}

func HandlerFromMuxWithBaseURL(si ServerInterface, r chi.Router, baseURL string) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{
		BaseURL:    baseURL,
		BaseRouter: r,
	})
}

// HandlerWithOptions creates http.Handler with additional options
func HandlerWithOptions(si ServerInterface, options ChiServerOptions) http.Handler {
	r := options.BaseRouter

	if r == nil {
		r = chi.NewRouter()
	}
	if options.ErrorHandlerFunc == nil {
		options.ErrorHandlerFunc = func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusBadRequest)
		}
	}
	wrapper := ServerInterfaceWrapper{
		Handler:            si,
		HandlerMiddlewares: options.Middlewares,
		ErrorHandlerFunc:   options.ErrorHandlerFunc,
	}

	r.Group(func(r chi.Router) {
		r.Post(options.BaseURL+"/VWL", wrapper.PostVWL)
	})

	return r
}

type PostVWLRequestObject struct {
	Params PostVWLParams
}

type PostVWLResponseObject interface {
	VisitPostVWLResponse(w http.ResponseWriter) error
}

type PostVWL200Response struct {
}

func (response PostVWL200Response) VisitPostVWLResponse(w http.ResponseWriter) error {
	w.WriteHeader(200)
	return nil
}

// StrictServerInterface represents all server handlers.
type StrictServerInterface interface {

	// (POST /VWL)
	PostVWL(ctx context.Context, request PostVWLRequestObject) (PostVWLResponseObject, error)
}

type StrictHandlerFunc = strictnethttp.StrictHttpHandlerFunc
type StrictMiddlewareFunc = strictnethttp.StrictHttpMiddlewareFunc

type StrictHTTPServerOptions struct {
	RequestErrorHandlerFunc  func(w http.ResponseWriter, r *http.Request, err error)
	ResponseErrorHandlerFunc func(w http.ResponseWriter, r *http.Request, err error)
}

func NewStrictHandler(ssi StrictServerInterface, middlewares []StrictMiddlewareFunc) ServerInterface {
	return &strictHandler{ssi: ssi, middlewares: middlewares, options: StrictHTTPServerOptions{
		RequestErrorHandlerFunc: func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusBadRequest)
		},
		ResponseErrorHandlerFunc: func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusInternalServerError)
		},
	}}
}

func NewStrictHandlerWithOptions(ssi StrictServerInterface, middlewares []StrictMiddlewareFunc, options StrictHTTPServerOptions) ServerInterface {
	return &strictHandler{ssi: ssi, middlewares: middlewares, options: options}
}

type strictHandler struct {
	ssi         StrictServerInterface
	middlewares []StrictMiddlewareFunc
	options     StrictHTTPServerOptions
}

// PostVWL operation middleware
func (sh *strictHandler) PostVWL(w http.ResponseWriter, r *http.Request, params PostVWLParams) {
	var request PostVWLRequestObject

	request.Params = params

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.PostVWL(ctx, request.(PostVWLRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "PostVWL")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(PostVWLResponseObject); ok {
		if err := validResponse.VisitPostVWLResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/6SUQW/jRgyF/wrB9ihLTvamU3cX3SKACwTI1jnUPYwlymIzmpmSlNI08H8vRnXWaWKk",
	"DnqUQA6/94bzHrGJQ4qBginWj5icuIGMZP76cvN5fbu6eVAjGvKPlrQRTsYxYI3cUjDumAS6KGA9geba",
	"AZLEhlQ57Oa/E8k9yR2HHRbIubUn15JggcENhHWetFjfrhZPswrUpqfB5aH0pxuSz1XbacIC7SHlDzXJ",
	"B+73xYFzTeKC3ccoLXn+/Y5eE2eY5MQeQEhTDMpbT9/gj5gFWM8KbSSFEA16NxFYhC3B8Yg2vtYHbEq+",
	"+y+Zr1FPC26ie1twHkvyltBTlGfJe9uhMxQe2P6HMg47/dgYT2zEdmoBIXYvb2A+8zy6fP7i2YDnqF2U",
	"wRnWOAovjIbkndF5yDfJhRNXIi6oa/IXjOMRnUMThwwu9MdIau9hnyedph65PUGbeTl0Mdc2MZhrZltp",
	"cOyxxpZ37N32hynsyuBxX7zQ8DWvDSs46HhW4jx8Wq/h4/UVWO8MlGQiBafgAhxu+9v2bPBzHIYY4CeJ",
	"Y2jhZ96JM6Y7Mgrwhcm33m03WG7ClYFQEtIcTOBAB+c96LhVsifjhJxf3EfxLWzwk1PWKUb5iylkN9dC",
	"NOTXFXYUNlhigZ4bCjrHwsHTH3+5XsFFeYkFjpIN6M2S1lVFY/IljdVFeVlRqLITxjZv7vp2lfVigROJ",
	"/uPLRbksl7koJgouMdb4oVyWH7DA5Kyfw7Ra367miI16YpW/khrk2gwaE2VjYrhqscbrqJZ7i3+l86+P",
	"+L1QhzV+Vx0zvDqWVG89pX3x/vZ52c5ufEry904ieVfLixjd/1bgIbhodv1yuXxtdrybn8J+/3cAAAD/",
	"//g5i4X/BgAA",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %w", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %w", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %w", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	res := make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	resolvePath := PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		pathToFile := url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
